DECLARE FUNCTION FF7toDOS$ (FF7Str$)
DECLARE SUB PrintFile ()
DECLARE SUB UncompressFile ()
DECLARE SUB ViewFile ()
DECLARE SUB MovePos (KeyInp$)
DECLARE SUB PrintFileList ()
DECLARE SUB QuickSeek (SearchKey$)

DIM SHARED BasePnt&, CD$
DIM SHARED CursorPos%, ScreenPos%, TextPos%
DIM SHARED FileNum%, PointNum%

WIDTH 80, 50
COLOR 15

DO
  INPUT "Enter CD Drive Letter: ", CD$
  CD$ = LTRIM$(RTRIM$(CD$))
LOOP UNTIL LEN(CD$) = 1

OPEN "FF7TV-3.LST" FOR INPUT AS #1
INPUT #1, FileNum%
IF NOT EOF(1) THEN
  DIM SHARED FileList$(FileNum% - 1)
  FOR File% = 0 TO FileNum% - 1
    INPUT #1, FileList$(File%)
  NEXT File%
END IF
CLOSE #1

CursorPos% = 0: ScreenPos% = 0
CALL PrintFileList

DO
  DO
    KeyInp$ = INKEY$
  LOOP UNTIL KeyInp$ <> ""

  KeyInp$ = UCASE$(KeyInp$)
  SELECT CASE ASC(KeyInp$)
    CASE 13, 32: CALL ViewFile
    CASE 48 TO 57, 65 TO 90: CALL QuickSeek(KeyInp$)
    CASE ELSE: CALL MovePos(KeyInp$)
  END SELECT

  CALL PrintFileList
LOOP UNTIL KeyInp$ = CHR$(27)

FUNCTION FF7toDOS$ (FF7Str$)
  DOSStr$ = ""

  SELECT CASE ASC(FF7Str$)
    CASE IS <= 90: DOSStr$ = CHR$(ASC(FF7Str$) + 32)
    CASE 169: DOSStr$ = "..."
    CASE 178, 179: DOSStr$ = CHR$(34)
    CASE 180: DOSStr$ = "'"
    CASE 226: DOSStr$ = ", "
    CASE 231: DOSStr$ = CHR$(13)
    CASE 232: DOSStr$ = CHR$(13) + CHR$(13)
    CASE 234: DOSStr$ = "CLOUD"
    CASE 235: DOSStr$ = "BARRET"
    CASE 236: DOSStr$ = "TIFA"
    CASE 237: DOSStr$ = "AERIS"
    CASE 238: DOSStr$ = "RED XII"
    CASE 239: DOSStr$ = "YUFFIE"
    CASE 240: DOSStr$ = "CAIT SITH"
    CASE 241: DOSStr$ = "VINCENT"
    CASE 242: DOSStr$ = "CID"
    CASE 234: DOSStr$ = "{1}"
    CASE 235: DOSStr$ = "{2}"
    CASE 236: DOSStr$ = "{3}"
    CASE 246: DOSStr$ = "{O}"
    CASE 247: DOSStr$ = "{T}"
    CASE 248: DOSStr$ = "{S}"
    CASE 249: DOSStr$ = "{X}"
    CASE ELSE: DOSStr$ = ""
  END SELECT

  FF7toDOS$ = DOSStr$
END FUNCTION

SUB MovePos (KeyInp$)
  IF LEN(KeyInp$) = 2 THEN
    SELECT CASE ASC(RIGHT$(KeyInp$, 1))
      CASE 72
        IF CursorPos% - 7 >= 0 THEN
          CursorPos% = CursorPos% - 7
          IF CursorPos% < ScreenPos% THEN
            ScreenPos% = ScreenPos% - 7
          END IF
        END IF

      CASE 75
        IF CursorPos% - 1 >= 0 THEN
          CursorPos% = CursorPos% - 1
          IF CursorPos% < ScreenPos% THEN
            ScreenPos% = ScreenPos% - 1
          END IF
        END IF

      CASE 77
        IF CursorPos% + 1 < FileNum% THEN
          CursorPos% = CursorPos% + 1
          IF CursorPos% >= ScreenPos% + 280 THEN
            ScreenPos% = ScreenPos% + 1
          END IF
        END IF

      CASE 80
        IF CursorPos% + 7 < FileNum% THEN
          CursorPos% = CursorPos% + 7
          IF CursorPos% >= ScreenPos% + 280 THEN
            ScreenPos% = ScreenPos% + 7
          END IF
        END IF
    END SELECT
  END IF

  IF ScreenPos% < 0 THEN ScreenPos% = 0
END SUB

SUB PrintFile
  DIM S1Byte AS STRING * 1

  COLOR 14
  LOCATE 1, 1
  FOR Rep% = 1 TO 49
    SELECT CASE Rep%
      CASE 1: PRINT "" + STRING$(78, "") + "";
      CASE 3, 44: PRINT "" + STRING$(78, "") + "";
      CASE 49: PRINT "" + STRING$(78, "") + "";
      CASE ELSE: PRINT ""; SPC(78); "";
    END SELECT
  NEXT Rep%
      
  COLOR 15
  LOCATE 2, 2: PRINT "Final Fantasy 7 Text Viewer v3.0";
  LOCATE 45, 2: PRINT "Current Text Section:" + STR$(TextPos% + 1);
  LOCATE 46, 2: PRINT "Total Text Sections:" + STR$(PointNum%);
  LOCATE 47, 2: PRINT "Left/Right: Change Section";
  LOCATE 48, 2: PRINT "Esc: Quit"

  OPEN "FF7TV-3.TMP" FOR BINARY AS #1
  GET #1, BasePnt& + TextPos% * 2 + 3, S1Byte$
  TextPnt& = ASC(S1Byte$)
  TextPnt& = TextPnt& * 256
  GET #1, BasePnt& + TextPos% * 2 + 2, S1Byte$
  TextPnt& = TextPnt& + ASC(S1Byte$)

  LOCATE 4, 2
  SEEK #1, BasePnt& + TextPnt&
  DO
    GET #1, , S1Byte$
    IF ASC(S1Byte$) < 255 THEN PRINT FF7toDOS$(S1Byte$);
    IF POS(0) < 2 THEN LOCATE CSRLIN, 2
  LOOP UNTIL ASC(S1Byte$) = 255
  CLOSE
END SUB

SUB PrintFileList
  COLOR 14
  LOCATE 1, 1
  FOR Rep% = 1 TO 49
    SELECT CASE Rep%
      CASE 1: PRINT "" + STRING$(78, "") + "";
      CASE 3, 44: PRINT "" + STRING$(78, "") + "";
      CASE 49: PRINT "" + STRING$(78, "") + "";
      CASE ELSE: PRINT ""; SPC(78); "";
    END SELECT
  NEXT Rep%
       
  COLOR 15
  LOCATE 2, 2: PRINT "Final Fantasy 7 Text Viewer v3.0";
  LOCATE 45, 2: PRINT "Arrows: Move Cursor";
  LOCATE 46, 2: PRINT "0-9, A-Z: Quick Seek";
  LOCATE 47, 2: PRINT "Enter/Space: View File";
  LOCATE 48, 2: PRINT "Esc: Quit"
 
  FOR YPos% = 0 TO 39
    FOR XPos% = 0 TO 6
      IF ScreenPos% + XPos% + 7 * YPos% < FileNum% THEN
        CurFile$ = FileList$(ScreenPos% + XPos% + 7 * YPos%)
        CurFile$ = CurFile$ + LEFT$("          ", 8 - LEN(CurFile$))

        LOCATE YPos% + 4, XPos% * 11 + 2
        IF ScreenPos% + XPos% + 7 * YPos% = CursorPos% THEN
          COLOR 15
        ELSE
          COLOR 7
        END IF
        PRINT CurFile$;
      END IF
    NEXT XPos%
  NEXT YPos%
END SUB

SUB QuickSeek (SearchKey$)
  CursorPos% = -1
  DO
    CursorPos% = CursorPos% + 1
  LOOP UNTIL (LEFT$(FileList$(CursorPos%), 1) >= SearchKey$)
  ScreenPos% = CursorPos%
END SUB

SUB UncompressFile
  DIM CmpBuffer(4095) AS STRING * 1
  DIM CmpFlag AS STRING * 1
  DIM S1Byte AS STRING * 1

  CmpIndex% = 4078
  FOR CmpByte% = 0 TO 4095
    CmpBuffer$(CmpByte%) = CHR$(0)
  NEXT CmpByte%

  OPEN CD$ + ":\FIELD\" + FileList$(CursorPos%) + ".DAT" FOR BINARY AS #1
  OPEN "FF7TV-3.TMP" FOR BINARY AS #2

  SEEK #1, 5
  DO
    GET #1, , CmpFlag$

    FOR CurByte% = 0 TO 7
      IF (ASC(CmpFlag$) AND 2 ^ CurByte%) = 0 THEN
        GET #1, , S1Byte$
        CmpOff% = ASC(S1Byte$)

        GET #1, , S1Byte$
        CmpOff% = CmpOff% + (ASC(S1Byte$) AND 240) * 16
        CmpLen% = (ASC(S1Byte$) AND 15) + 3

        FOR CmpByte% = 0 TO CmpLen% - 1
          S1Byte$ = CmpBuffer$((CmpOff% + CmpByte%) AND 4095)
          CmpBuffer$(CmpIndex%) = S1Byte$
          CmpIndex% = (CmpIndex% + 1) AND 4095
          PUT #2, , S1Byte$
        NEXT CmpByte%

      ELSE
        GET #1, , S1Byte$
        CmpBuffer$(CmpIndex%) = S1Byte$
        CmpIndex% = (CmpIndex% + 1) AND 4095
        PUT #2, , S1Byte$
      END IF
    NEXT CurByte%
  LOOP UNTIL EOF(1)
  CLOSE
END SUB

SUB ViewFile
  DIM S1Byte AS STRING * 1
  CALL UncompressFile
  OPEN "FF7TV-3.TMP" FOR BINARY AS #1
 
  GET #1, 34, S1Byte$
  BasePnt& = ASC(S1Byte$)
  BasePnt& = BasePnt& * 256
  GET #1, 33, S1Byte$
  BasePnt& = BasePnt& + ASC(S1Byte$)
  BasePnt& = BasePnt& + 29

  GET #1, BasePnt& + 3, S1Byte$
  TextPnt& = ASC(S1Byte$)
  TextPnt& = TextPnt& * 256
  GET #1, BasePnt& + 2, S1Byte$
  TextPnt& = TextPnt& + ASC(S1Byte$)
  CLOSE

  PointNum% = (TextPnt& - 2) / 2
  TextPos% = 0
  CALL PrintFile
  DO
    DO
      KeyInp$ = INKEY$
    LOOP UNTIL KeyInp$ <> ""

    IF LEN(KeyInp$) = 2 THEN
      SELECT CASE ASC(RIGHT$(KeyInp$, 1))
        CASE 75: IF TextPos% > 0 THEN TextPos% = TextPos% - 1
        CASE 77: IF TextPos% < PointNum% - 1 THEN TextPos% = TextPos% + 1
      END SELECT
     
      CALL PrintFile
    END IF

    KeyInp$ = UCASE$(KeyInp$)
  LOOP UNTIL KeyInp$ = CHR$(27)
 
  CLS
  CALL PrintFileList
END SUB

